from websocket_server import WebsocketServer
srvs = list()
clis = list()

# Called for every client connecting (after handshake)
def new_client(client, server):
	#clientsConnected = clientsConnected + 1
	print("New client connected and was given id %d" % client['id'])
	server.send_message_to_all("Hey all, a new client has joined us")


# Called for every client disconnecting
def client_left(client, server):
	global srvs
	global clis
	for srv in srvs:
		if srv['id'] == client['id']:
			srvs.remove(srv)
			answer = "Servers:" + str(len(srvs))
			server.send_message_to_all(answer)
	for cli in clis:
		if cli['id'] == client['id']:
			clis.remove(cli)
	print("Client(%d) disconnected" % client['id'])


# Called when a client sends a message
def message_received(client, server, message):
	global srvs
	global clis
	print("Client(%d) said: %s" % (client['id'], message))
	if len(message) > 200:
		message = message[:200]+'..'
	if message == "Servers?":
		answer = "Servers:" + str(len(srvs))
		print ("Answered: " + answer)
		server.send_message(client, answer)
	elif message == "Clients?":
		answer = "Clients:" + str(len(clis))
		print ("Answered: " + answer)
		server.send_message(client, answer)
	elif message.startswith("SendPage:"):
		server.send_message_to_all(message)
	elif message == "PageServer!":
		srvs.append(client)
		answer = "Servers:" + str(len(srvs))
		server.send_message_to_all(answer)
	elif message == "GUIClient!":
		clis.append(client)


PORT=55001
server = WebsocketServer(PORT, host='192.168.10.52')
server.set_fn_new_client(new_client)
server.set_fn_client_left(client_left)
server.set_fn_message_received(message_received)
server.run_forever()
